<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="/layout/template.xhtml">

    <ui:define name="content">
        <div>
            <h1>Index for ANS-HL7V2-SIMULATOR-Configuration-SUT</h1>
        </div>

        <div class="card crud-demo">
            <h:form id="form">
                <p:growl id="messages" showDetail="true"/>

                <p:toolbar>
                    <p:toolbarGroup>
                        <p:commandButton value="New" icon="pi pi-plus"
                                         actionListener="#{configurationSUTBean.openNew()}"
                                         update=":dialogs:manage-configuration-content"
                                         oncomplete="PF('manageConfigurationDialog').show()"
                                         styleClass="ui-button-success" style="margin-right: .5rem">
                            <p:resetInput target=":dialogs:manage-configuration-content"/>
                        </p:commandButton>
                    </p:toolbarGroup>

                </p:toolbar>

                <p:dataTable id="dt-configurations" widgetVar="dtConfigurations" var="configuration"
                             value="#{configurationSUTBean.getAll()}"
                             reflow="true" styleClass="configurations-table"
                             rowKey="#{configuration.getId()}" paginator="true" rows="10" rowSelectMode="add"
                             paginatorPosition="bottom">


                    <p:column headerText="Id">
                        <h:outputText value="#{configuration.id}"/>
                    </p:column>
                    <p:column headerText="Name">
                        <h:outputText value="#{configuration.name}"/>
                    </p:column>
                    <p:column headerText="Host/Ip">
                        <h:outputText value="#{configuration.host}"/>
                    </p:column>
                    <p:column headerText="Port">
                        <h:outputText value="#{configuration.port}">
                        </h:outputText>
                    </p:column>
                    <p:column headerText="Application">
                        <h:outputText value="#{configuration.application}"/>
                    </p:column>
                    <p:column headerText="Facility">
                        <h:outputText value="#{configuration.facility}"/>
                    </p:column>
                    <p:column headerText="Owner">
                        <h:outputText value="#{configuration.owner}"/>
                    </p:column>
                    <p:column headerText="Company Owner">
                        <h:outputText value="#{configuration.companyOwner}"/>
                    </p:column>
                    <p:column headerText="isShare">
                        <h:outputText value="#{configuration.isShare()}"/>
                    </p:column>
                    <p:column headerText="Charset">
                        <h:outputText value="#{configuration.charset}"/>
                    </p:column>
                    <p:column rendered="#{getPrincipal.admin or getPrincipal.organizationKeyword eq configuration.companyOwner}" exportable="false">
                        <p:commandButton icon="pi pi-pencil" update=":dialogs:manage-configuration-content"
                                         oncomplete="PF('manageConfigurationDialog').show()"
                                         styleClass="edit-button rounded-button ui-button-success">
                            <f:setPropertyActionListener value="#{configuration}"
                                                         target="#{configurationSUTBean.selectedConfigurationSUT}"/>
                            <p:resetInput target=":dialogs:manage-configuration-content"/>
                        </p:commandButton>
                        <p:commandButton class="ui-button-warning rounded-button" icon="pi pi-trash"

                                         oncomplete="PF('deleteConfigurationDialog').show()">
                            <f:setPropertyActionListener value="#{configuration}"
                                                         target="#{configurationSUTBean.selectedConfigurationSUT}"/>
                        </p:commandButton>
                    </p:column>

                </p:dataTable>
            </h:form>

            <h:form id="dialogs">
                <p:dialog header="Configuration Details" showEffect="fade" modal="true"
                          widgetVar="manageConfigurationDialog"
                          responsive="true">
                    <p:outputPanel id="manage-configuration-content" class="ui-fluid">
                        <p:outputPanel rendered="#{not empty configurationSUTBean.selectedConfigurationSUT}">
                            <div class="field">
                                <div class="field">
                                    <p:outputLabel for="name">Name</p:outputLabel>
                                    <p:inputText id="name" value="#{configurationSUTBean.name}"
                                    />
                                    <p:outputLabel for="host">HOST</p:outputLabel>
                                    <p:inputText id="host" value="#{configurationSUTBean.host}"
                                    />
                                </div>
                                <div class="field">
                                    <p:outputLabel for="port">PORT</p:outputLabel>
                                    <p:inputText id="port" value="#{configurationSUTBean.port}"
                                    />
                                </div>

                            </div>
                            <div class="field">
                                <p:outputLabel for="application">APPLICATION</p:outputLabel>
                                <p:inputText id="application" value="#{configurationSUTBean.application}"
                                />
                            </div>
                            <div class="field">
                                <p:outputLabel for="facility">FACILITY</p:outputLabel>
                                <p:inputText id="facility" value="#{configurationSUTBean.facility}"
                                />
                            </div>
                            <p:outputLabel for="charsets" value="Charset: "/>
                            <p:selectOneMenu id="charsets" value="#{configurationSUTBean.charset}" style="margin-bottom:5px;">
                                <f:selectItems value="#{configurationSUTBean.getCharsets()}"/>
                            </p:selectOneMenu>

                            <div class="field">
                                <p:selectBooleanCheckbox id="isShare" value="#{configurationSUTBean.share}"
                                                         style="margin-right:5px;"/>
                                <p:outputLabel for="isShare">Make this configuration public ?</p:outputLabel>
                            </div>

                        </p:outputPanel>
                    </p:outputPanel>
                    <f:facet name="footer">
                        <p:commandButton value="Save" icon="pi pi-check"
                                         action="#{configurationSUTBean.insertUpdateSelectedConfigurationSUT()}"

                        />
                        <p:commandButton value="Cancel" icon="pi pi-times"
                                         onclick="PF('manageConfigurationDialog').hide()"
                                         class="ui-button-secondary" type="button"/>
                    </f:facet>
                </p:dialog>

                <p:confirmDialog widgetVar="deleteConfigurationDialog" showEffect="fade" width="300"
                                 message="Delete the configuration?" header="Confirm" severity="warn">
                    <p:commandButton value="Yes" icon="pi pi-check"
                                     actionListener="#{configurationSUTBean.deleteSelectedConfigurationSUT()}"
                                     oncomplete="PF('deleteConfigurationDialog').hide()"
                                     update="@this"/>
                    <p:commandButton value="No" type="button" styleClass="ui-button-secondary" icon="pi pi-times"
                                     onclick="PF('deleteConfigurationDialog').hide()"/>
                </p:confirmDialog>

                <p:confirmDialog global="true" showEffect="fade" width="300">
                    <p:commandButton value="Yes" type="button" styleClass="ui-confirmdialog-yes" icon="pi pi-check"/>
                    <p:commandButton value="No" type="button" styleClass="ui-confirmdialog-no ui-button-secondary"
                                     icon="pi pi-times"/>
                </p:confirmDialog>
            </h:form>


        </div>
    </ui:define>
</ui:composition>
